/*===========================================================================
 *  Filename : functable-srfi1.c
 *  About    : Built-in function table
 *             This file is auto-generated by build_func_table.rb
 *
 *  Copyright (C) 2005-2006 Kazuki Ohta <mover AT hct.zaq.ne.jp>
 *  Copyright (c) 2007 SigScheme Project <uim AT freedesktop.org>
 *
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of authors nor the names of its contributors
 *     may be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 *  IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 *  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
===========================================================================*/

#include <stddef.h>

#include "sigscheme.h"


static const struct scm_func_registration_info scm_functable_srfi1[] = {
    /* module-srfi1.c */
    { "xcons", (ScmFuncType)scm_p_srfi1_xcons, SCM_PROCEDURE_FIXED_2 },
    { "cons*", (ScmFuncType)scm_p_srfi1_consstar, SCM_PROCEDURE_VARIADIC_0 },
    { "make-list", (ScmFuncType)scm_p_srfi1_make_list, SCM_PROCEDURE_VARIADIC_1 },
    { "list-tabulate", (ScmFuncType)scm_p_srfi1_list_tabulate, SCM_PROCEDURE_VARIADIC_1 },
    { "list-copy", (ScmFuncType)scm_p_srfi1_list_copy, SCM_PROCEDURE_FIXED_1 },
    { "circular-list", (ScmFuncType)scm_p_srfi1_circular_list, SCM_PROCEDURE_VARIADIC_0 },
    { "iota", (ScmFuncType)scm_p_srfi1_iota, SCM_PROCEDURE_VARIADIC_1 },
    { "proper-list?", (ScmFuncType)scm_p_srfi1_proper_listp, SCM_PROCEDURE_FIXED_1 },
    { "circular-list?", (ScmFuncType)scm_p_srfi1_circular_listp, SCM_PROCEDURE_FIXED_1 },
    { "dotted-list?", (ScmFuncType)scm_p_srfi1_dotted_listp, SCM_PROCEDURE_FIXED_1 },
    { "not-pair?", (ScmFuncType)scm_p_srfi1_not_pairp, SCM_PROCEDURE_FIXED_1 },
    { "null-list?", (ScmFuncType)scm_p_srfi1_null_listp, SCM_PROCEDURE_FIXED_1 },
    { "list=", (ScmFuncType)scm_p_srfi1_listequal, SCM_PROCEDURE_VARIADIC_1 },
    { "first", (ScmFuncType)scm_p_srfi1_first, SCM_PROCEDURE_FIXED_1 },
    { "second", (ScmFuncType)scm_p_srfi1_second, SCM_PROCEDURE_FIXED_1 },
    { "third", (ScmFuncType)scm_p_srfi1_third, SCM_PROCEDURE_FIXED_1 },
    { "fourth", (ScmFuncType)scm_p_srfi1_fourth, SCM_PROCEDURE_FIXED_1 },
    { "fifth", (ScmFuncType)scm_p_srfi1_fifth, SCM_PROCEDURE_FIXED_1 },
    { "sixth", (ScmFuncType)scm_p_srfi1_sixth, SCM_PROCEDURE_FIXED_1 },
    { "seventh", (ScmFuncType)scm_p_srfi1_seventh, SCM_PROCEDURE_FIXED_1 },
    { "eighth", (ScmFuncType)scm_p_srfi1_eighth, SCM_PROCEDURE_FIXED_1 },
    { "ninth", (ScmFuncType)scm_p_srfi1_ninth, SCM_PROCEDURE_FIXED_1 },
    { "tenth", (ScmFuncType)scm_p_srfi1_tenth, SCM_PROCEDURE_FIXED_1 },
    { "car+cdr", (ScmFuncType)scm_p_srfi1_carpluscdr, SCM_PROCEDURE_FIXED_1 },
    { "take", (ScmFuncType)scm_p_srfi1_take, SCM_PROCEDURE_FIXED_2 },
    { "drop", (ScmFuncType)scm_p_srfi1_drop, SCM_PROCEDURE_FIXED_2 },
    { "take-right", (ScmFuncType)scm_p_srfi1_take_right, SCM_PROCEDURE_FIXED_2 },
    { "drop-right", (ScmFuncType)scm_p_srfi1_drop_right, SCM_PROCEDURE_FIXED_2 },
    { "take!", (ScmFuncType)scm_p_srfi1_takex, SCM_PROCEDURE_FIXED_2 },
    { "drop-right!", (ScmFuncType)scm_p_srfi1_drop_rightx, SCM_PROCEDURE_FIXED_2 },
    { "split-at", (ScmFuncType)scm_p_srfi1_split_at, SCM_PROCEDURE_FIXED_2 },
    { "split-at!", (ScmFuncType)scm_p_srfi1_split_atx, SCM_PROCEDURE_FIXED_2 },
    { "last", (ScmFuncType)scm_p_srfi1_last, SCM_PROCEDURE_FIXED_1 },
    { "last-pair", (ScmFuncType)scm_p_srfi1_last_pair, SCM_PROCEDURE_FIXED_1 },
    { "length+", (ScmFuncType)scm_p_srfi1_lengthplus, SCM_PROCEDURE_FIXED_1 },
    { "concatenate", (ScmFuncType)scm_p_srfi1_concatenate, SCM_PROCEDURE_VARIADIC_0 },

    { NULL, NULL, SCM_FUNCTYPE_INVALID }
};
